require 'fleetctl/setup'
require 'fleetctl/setup/aws/cloud_formation_search'

module Fleetctl::Setup
  module AWS
    class Search
      class <<self
        def search(search_term)
          new(search_term).results
        end

        def service_classes
          {
            cloud_formation: CloudFormationSearch
          }
        end
      end

      def initialize(search_term)
        @search_term = search_term
      end

      def results
        [].tap do |results|
          self.class.service_classes.values.each do |klass|
            results.concat klass.search(@search_term)
          end
        end
      end
    end
  end
end

